/****************************************************************************** 
 * Job:             Load_STG2DM_Product_hier_assoc_dm       A5W0V4GZ.BF0002JJ * 
 * Description:                                                               * 
 *                                                                            * 
 * Metadata Server: puneasd10.apac.sas.com                                    * 
 * Port:            8561                                                      * 
 * Location:        /Users/Rhuta/My Folder/Job_Cycle7                         * 
 *                                                                            * 
 * Server:          MIMain                                  A5W0V4GZ.AR000003 * 
 *                                                                            * 
 * Source Tables:   STG_PRODUCT_HIERARCHY -                 A5W0V4GZ.BB000APA * 
 *                   DIDM_STG.STG_PRODUCT_HIERARCHY                           * 
 *                  PROD_HIER_SK - DI_MON.PROD_HIER_SK      A5W0V4GZ.BB000ALQ * 
 *                  PRODUCT_LVL - DI_DM.PRODUCT_LVL         A5W0V4GZ.BB000AJU * 
 *                  PARENT_PROD_HIER_SK -                   A5W0V4GZ.BB000ALP * 
 *                   DI_MON.PARENT_PROD_HIER_SK                               * 
 *                  PARENT_PROD_HIER_SK -                   A5W0V4GZ.BB000ALP * 
 *                   DI_MON.PARENT_PROD_HIER_SK                               * 
 *                  PRODUCT_HIER_ASSOC_DM -                 A5W0V4GZ.BB000AJT * 
 *                   DI_DM.PRODUCT_HIER_ASSOC_DM                              * 
 * Target Tables:   PARENT_PROD_HIER_SK -                   A5W0V4GZ.BB000ALP * 
 *                   DI_MON.PARENT_PROD_HIER_SK                               * 
 *                  PRODUCT_HIER_ASSOC_DM -                 A5W0V4GZ.BB000AJT * 
 *                   DI_DM.PRODUCT_HIER_ASSOC_DM                              * 
 *                  HIERARCHY_HISTORY -                     A5W0V4GZ.BB000AHT * 
 *                   DI_DM.HIERARCHY_HISTORY                                  * 
 *                                                                            * 
 * Generated on:    Monday, November 2, 2009 3:46:47 PM IST                   * 
 * Generated by:    sinruk@row                                                * 
 * Version:         SAS Data Integration Studio 4.2                           * 
 ******************************************************************************/ 

/* General macro variables  */ 
%let jobID = %quote(A5W0V4GZ.BF0002JJ);
%let etls_jobName = %nrquote(Load_STG2DM_Product_hier_assoc_dm);
%let etls_userID = %nrquote(sinruk@row);

/* Setup to capture return codes  */ 
%global job_rc trans_rc sqlrc; 
%let sysrc = 0;
%let syscc = 0;
%let job_rc = 0;
%let trans_rc = 0;
%let sqlrc = 0;
%global syserr; 

%macro rcSet(error); 
   %if (&error gt &trans_rc) %then 
      %let trans_rc = &error;
   %if (&error gt &job_rc) %then 
      %let job_rc = &error;
%mend rcSet; 

%macro rcSetDS(error); 
   if &error gt input(symget('trans_rc'),12.) then 
      call symput('trans_rc',trim(left(put(&error,12.))));
   if &error gt input(symget('job_rc'),12.) then 
      call symput('job_rc',trim(left(put(&error,12.))));
%mend rcSetDS; 

/* Create metadata macro variables */
%let IOMServer      = %nrquote(MIMain);

/* Setup for capturing job status  */ 
%let etls_startTime = %sysfunc(datetime(),datetime.);
%let etls_recordsBefore = 0;
%let etls_recordsAfter = 0;
%let etls_lib = 0;
%let etls_table = 0;

%global etls_debug; 
%macro etls_setDebug; 
   %if %str(&etls_debug) ne 0 %then 
      OPTIONS MPRINT%str(;); 
%mend; 
%etls_setDebug; 

/*---- Start of Pre-Process Code  ----*/ 

%etl_initjobparam (monlib=di_mon, jobname=%nrquote(&etls_jobName));
/**/
%etl_initchangeflags;

/*---- End of Pre-Process Code  ----*/ 

%rcSet(&syserr); 
%rcSet(&sqlrc); 

/*============================================================================* 
 * Step:            Lkp_prod_hier_sk                        A5W0V4GZ.BH000HDH * 
 * Transform:       Lookup                                                    * 
 * Description:                                                               * 
 *                                                                            * 
 * Source Tables:   STG_PRODUCT_HIERARCHY -                 A5W0V4GZ.BB000APA * 
 *                   DIDM_STG.STG_PRODUCT_HIERARCHY                           * 
 *                  PROD_HIER_SK - DI_MON.PROD_HIER_SK      A5W0V4GZ.BB000ALQ * 
 *                  PRODUCT_LVL - DI_DM.PRODUCT_LVL         A5W0V4GZ.BB000AJU * 
 * Target Table:    Lkp_prod_hier_sk -                      A5W0V4GZ.BK000E7L * 
 *                   work.VALID_PROD_HIER_SK                                  * 
 *============================================================================*/ 

%let transformID = %quote(A5W0V4GZ.BH000HDH);
%let trans_rc = 0;
%let etls_stepStartTime = %sysfunc(datetime(), datetime20.); 

%let runTime = %sysfunc(datetime()); 

/* Creating view to eliminate column name collisions for lookup table  */ 
/*  DI_MON.PROD_HIER_SK                                                */ 
proc datasets lib = work nolist nowarn memtype = (data view);
   delete etls_temp_lookupview1;
quit;

proc sql; create view etls_temp_lookupview1 as 
   select 
      PROD_HIER_SK as ETLS_W5RWSDJT,
      PROD_ID as ETLS_W5RWSDKD
   from DI_MON.PROD_HIER_SK
   ;
quit;

%rcSet(&syscc); 

/* Creating view to eliminate column name collisions for lookup table  */ 
/*  DI_DM.PRODUCT_LVL                                                  */ 
proc datasets lib = work nolist nowarn memtype = (data view);
   delete etls_temp_lookupview2;
quit;

proc sql; create view etls_temp_lookupview2 as 
   select 
      PROD_LVL as ETLS_W5RWSDKN,
      PROD_HIER_ASSOC_CD as ETLS_W5RWSDK3,
      PROD_HIER_ASSOC_CD,
      PROD_LVL
   from DI_DM.PRODUCT_LVL
   ;
quit;

%rcSet(&syscc); 

proc datasets lib = work nolist nowarn memtype = (data view);
   delete VALID_PROD_HIER_SK;
quit;

/*---- Begin DATA step to perform lookups  ----*/ 
DATA  work.VALID_PROD_HIER_SK
         ( keep = PROD_HIER_ASSOC_CD PROD_ID PROD_LVL PARENT_PROD_ID PROD_HIER_SK 
                 PARENT_PROD_HIER_SK LK_PROD_HIER_ASSOC_CD LK_PROD_LVL )
      ; 
   
   attrib PROD_HIER_ASSOC_CD length=4
          PROD_ID length=$32
          PROD_LVL length=4
          PARENT_PROD_ID length=$32
          PROD_HIER_SK length=6
          PARENT_PROD_HIER_SK length=6
          LK_PROD_HIER_ASSOC_CD length=4
          LK_PROD_LVL length=4
          ETLS_W5RWSDJT length= 6
          ETLS_W5RWSDKD length= $32
          ETLS_W5RWSDKN length= 4
          ETLS_W5RWSDK3 length= 4
          ; 
   
   retain missing0-missing2 0; 
   
   etls_assign_target_value = 0; 
   /* Build hash objects from lookup tables before reading first source row  */ 
   if (_n_ = 1) then 
   do; 
      /* Build hash h0 from lookup table DI_MON.PROD_HIER_SK */ 
      nlobs = .; 
      dsid = open("DI_MON.PROD_HIER_SK"); 
      if (dsid > 0) then 
      do; 
         if ( attrc(dsid, 'MTYPE') = 'DATA' ) then 
            nlobs = attrn(dsid, 'NLOBS'); 
         else 
            nlobs = -1; 
            
         dsid = close(dsid); 
         if (nlobs ^= 0) then 
         do; 
            if (nlobs > 0) then 
               exponent = ceil(log2(nlobs)); 
            else 
               exponent = 8; 
            declare hash h0(dataset: "DI_MON.PROD_HIER_SK", hashexp: exponent);
            h0.defineKey( "PROD_ID");
            h0.defineData( "PROD_HIER_SK");
            h0.defineDone();
            if (nlobs = -1) then 
            do; 
               if (h0.Num_Items < 1) then
               do; 
                  put "NOTE: Lookup table is empty: DI_MON.PROD_HIER_SK";
                  missing0 = 98; 
               end; 
            end; 
         end; 
         else 
         do; 
            put "NOTE: Lookup table is empty: DI_MON.PROD_HIER_SK";
            missing0 = 98; 
         end; 
      end; 
      else 
      do; 
         put "NOTE: Lookup table does not exist or cannot be opened:"
              " DI_MON.PROD_HIER_SK";
         
         put "NOTE: Abort action indicated, condition= Lookup table missing:"
              " DI_MON.PROD_HIER_SK";
         
         abort 3; 
      end; 
      
      /* Build hash h1 from lookup table etls_temp_lookupview1 */ 
      nlobs = .; 
      dsid = open("etls_temp_lookupview1"); 
      if (dsid > 0) then 
      do; 
         if ( attrc(dsid, 'MTYPE') = 'DATA' ) then 
            nlobs = attrn(dsid, 'NLOBS'); 
         else 
            nlobs = -1; 
            
         dsid = close(dsid); 
         if (nlobs ^= 0) then 
         do; 
            if (nlobs > 0) then 
               exponent = ceil(log2(nlobs)); 
            else 
               exponent = 8; 
            declare hash h1(dataset: "etls_temp_lookupview1", hashexp: exponent);
            h1.defineKey( "ETLS_W5RWSDKD");
            h1.defineData( "ETLS_W5RWSDJT");
            h1.defineDone();
            if (nlobs = -1) then 
            do; 
               if (h1.Num_Items < 1) then
               do; 
                  put "NOTE: Lookup table is empty: etls_temp_lookupview1";
                  missing1 = 98; 
               end; 
            end; 
         end; 
         else 
         do; 
            put "NOTE: Lookup table is empty: etls_temp_lookupview1";
            missing1 = 98; 
         end; 
      end; 
      else 
      do; 
         put "NOTE: Lookup table does not exist or cannot be opened:"
              " etls_temp_lookupview1";
         
         put "NOTE: Abort action indicated, condition= Lookup table missing:"
              " etls_temp_lookupview1";
         
         abort 3; 
      end; 
      
      /* Build hash h2 from lookup table etls_temp_lookupview2 */ 
      nlobs = .; 
      dsid = open("etls_temp_lookupview2"); 
      if (dsid > 0) then 
      do; 
         if ( attrc(dsid, 'MTYPE') = 'DATA' ) then 
            nlobs = attrn(dsid, 'NLOBS'); 
         else 
            nlobs = -1; 
            
         dsid = close(dsid); 
         if (nlobs ^= 0) then 
         do; 
            if (nlobs > 0) then 
               exponent = ceil(log2(nlobs)); 
            else 
               exponent = 8; 
            declare hash h2(dataset: "etls_temp_lookupview2", hashexp: exponent);
            h2.defineKey( "PROD_HIER_ASSOC_CD",
                           "PROD_LVL");
            h2.defineData( "ETLS_W5RWSDKN",
                           "ETLS_W5RWSDK3");
            h2.defineDone();
            if (nlobs = -1) then 
            do; 
               if (h2.Num_Items < 1) then
               do; 
                  put "NOTE: Lookup table is empty: etls_temp_lookupview2";
                  missing2 = 98; 
               end; 
            end; 
         end; 
         else 
         do; 
            put "NOTE: Lookup table is empty: etls_temp_lookupview2";
            missing2 = 98; 
         end; 
      end; 
      else 
      do; 
         put "NOTE: Lookup table does not exist or cannot be opened:"
              " etls_temp_lookupview2";
         
         put "NOTE: Abort action indicated, condition= Lookup table missing:"
              " etls_temp_lookupview2";
         
         abort 3; 
      end; 
      
      call missing (PROD_ID, PROD_HIER_SK, ETLS_W5RWSDKD, ETLS_W5RWSDJT, 
                    PROD_HIER_ASSOC_CD, PROD_LVL, ETLS_W5RWSDKN, ETLS_W5RWSDK3); 
   
   end; /* All hash objects have been defined */
   
   /* Read a row from the source table  */ 
   set DIDM_STG.STG_PRODUCT_HIERARCHY end = eof;
   
   /* Is the current key value stored in hash h0?  */ 
   if (missing0 < 1) then 
   do; 
      rc0 = h0.find();
   end; 
   else 
      rc0 = missing0; 
      
   /* Is the current key value stored in hash h1?  */ 
   if (missing1 < 1) then 
   do; 
      ETLS_W5RWSDKD = PARENT_PROD_ID;
      rc1 = h1.find();
      PARENT_PROD_HIER_SK = ETLS_W5RWSDJT;
   end; 
   else 
      rc1 = missing1; 
      
   /* Is the current key value stored in hash h2?  */ 
   if (missing2 < 1) then 
   do; 
      rc2 = h2.find();
      LK_PROD_LVL = ETLS_W5RWSDKN;
      LK_PROD_HIER_ASSOC_CD = ETLS_W5RWSDK3;
   end; 
   else 
      rc2 = missing2; 
      
   /* Examine success of lookups  */ 
   if ( rc0=0 and rc1=0 and rc2=0 ) then 
   do; 
      /* Write row to target  */ 
      output work.VALID_PROD_HIER_SK; 
      return; 
   end; 
   else 
   do; 
      error_total + 1; 
      
      if (rc0 ^= 0) then 
      do; 
         exception_total + 1; 
         if (rc0 = 98) then 
         do; 
            /* Check: Lookup table has no rows-Write exception row  */ 
            /* Check: Lookup table has no rows-Set target columns to value  */ 
            /* Check: Lookup table has no rows-Set target columns to missing  */ 
            call missing (PROD_HIER_SK); 
            etls_assign_target_value = 1; 
         end; 
         
         else 
         do; 
            /* Check: Lookup value not found-Set target columns to missing  */ 
            call missing (PROD_HIER_SK); 
            etls_assign_target_value = 1; 
         end; 
      end; 
      
      if (rc1 ^= 0) then 
      do; 
         exception_total + 1; 
         if (rc1 = 98) then 
         do; 
            /* Check: Lookup table has no rows-Write exception row  */ 
            /* Check: Lookup table has no rows-Set target columns to value  */ 
            /* Check: Lookup table has no rows-Set target columns to missing  */ 
            call missing (PARENT_PROD_HIER_SK); 
            etls_assign_target_value = 1; 
         end; 
         
         else 
         do; 
            /* Check: Lookup value not found-Set target columns to missing  */ 
            call missing (PARENT_PROD_HIER_SK); 
            etls_assign_target_value = 1; 
         end; 
      end; 
      
      if (rc2 ^= 0) then 
      do; 
         exception_total + 1; 
         if (rc2 = 98) then 
         do; 
            /* Check: Lookup table has no rows-Write exception row  */ 
            /* Check: Lookup table has no rows-Set target columns to value  */ 
            /* Check: Lookup table has no rows-Set target columns to missing  */ 
            call missing (LK_PROD_LVL, LK_PROD_HIER_ASSOC_CD); 
            etls_assign_target_value = 1; 
         end; 
         
         else 
         do; 
            /* Check: Lookup value not found-Set target columns to missing  */ 
            call missing (LK_PROD_LVL, LK_PROD_HIER_ASSOC_CD); 
            etls_assign_target_value = 1; 
         end; 
      end; 
      
      /* Set target columns to value/missing requested?  */ 
      if (etls_assign_target_value eq 1) then 
         /* Write row to target  */ 
         output work.VALID_PROD_HIER_SK; 
   
   end; /* One or more lookups failed */
   
   if (eof = 1) then 
   do; 
      put "Source records with errors: " error_total ; 
      put "Total lookup exceptions: " exception_total ; 
   end; 

run; 

%rcSet(&syscc); 



/**  Step end Lkp_prod_hier_sk **/

/*============================================================================* 
 * Step:            Val_prod_hier_cd/prod_lvl               A5W0V4GZ.BH000HDI * 
 * Transform:       Data Validation                                           * 
 * Description:                                                               * 
 *                                                                            * 
 * Source Table:    Lkp_prod_hier_sk -                      A5W0V4GZ.BK000E7L * 
 *                   work.VALID_PROD_HIER_SK                                  * 
 * Target Table:    Data Validation - work.Val_prod_hier_cd A5W0V4GZ.BK000E7M * 
 *============================================================================*/ 

%let transformID = %quote(A5W0V4GZ.BH000HDI);
%let trans_rc = 0;
%let etls_stepStartTime = %sysfunc(datetime(), datetime20.); 

/*---- Start of Pre-Process Code  ----*/ 

%di_etl_keep_work_table(VALID_PROD_HIER_SK);
/*---- End of Pre-Process Code  ----*/ 

   /*---- Begin checks for Custom, Missing Values, and Invalid Values  ----*/ 
   data work.valid_stg_product_hierarchy
         (keep = PROD_HIER_ASSOC_CD PROD_ID PROD_LVL PARENT_PROD_ID PROD_HIER_SK 
                         PARENT_PROD_HIER_SK )
        work.etls_Errors
         (keep=%di_util_column_names(DI_MON.STG_PROD_HIER_X));
   
      /* Define lengths for columns with longer lengths in target  */ 
      attrib ETLS_EXCEPTION_COND length = $250; 
      attrib ETL_ERROR_JOBRUNTIME length = 8 format =datetime16. ;
      
      set VALID_PROD_HIER_SK end=eof;
      
      
      i_move = 0;
      
      /*---- Custom Validation: Invaild PROD_ID  ----*/ 
      if (missing(PROD_HIER_SK)) then 
      do; 
         ETLS_EXCEPTION_COND = put(cats(ETLS_EXCEPTION_COND,'0a'x,"%etl_msg(mid=5305,args=PROD_ID)"),$250.); 
      end;  /* if (missing(PROD_HIER_SK)) */
      else 
      do; 
      end;  /* else */
      
      /*---- Custom Validation: Invaild PARENT PRODUCT_ID  ----*/ 
      if ( missing(PARENT_PROD_HIER_SK )) then 
      do; 
         ETLS_EXCEPTION_COND = put(cats(ETLS_EXCEPTION_COND,'0a'x,"%etl_msg(mid=5305,args=PARENT_PROD_ID)"),$250.); 
      end;  /* if ( missing(PARENT_PROD_HIER_SK )) */
      else 
      do; 
      end;  /* else */
      
      /*---- Custom Validation: Invaild PROD_HIER_ASSOC_CD /PROD_LVL  ----*/ 
      if (MISSING(LK_PROD_HIER_ASSOC_CD)  & MISSING(  LK_PROD_LVL)) then 
      do; 
         ETLS_EXCEPTION_COND = put(cats(ETLS_EXCEPTION_COND,'0a'x,"%etl_msg(mid=5305,args=PROD_HIER_ASSOC_CD/PROD_LVL)"),$250.); 
      end;  /* if (MISSING(LK_PROD_HIER_ASSOC_CD)  & MISSING(  LK_PROD_LVL)) */
      else 
      do; 
      end;  /* else */
      
      /*---- Custom Validation: Remove Invalid records  ----*/ 
      if (ETLS_EXCEPTION_COND ne " ") then 
      do; 
         i_move = 1; 
      end;  /* if (ETLS_EXCEPTION_COND ne " ") */
      else 
      do; 
      end;  /* else */
      
      /* move record to error file  */ 
      if (i_move) then do;
         ETL_Error_JobRunTime = "&etls_stepStartTime"dt; 
         output work.etls_Errors;
      end;
      /* move record to output file  */ 
      else 
         output work.valid_stg_product_hierarchy;      
   run; 
   
   %rcSet(&syscc);    
   
   /* Append the errors table  */ 
proc append base = DI_MON.STG_PROD_HIER_X 
   data=WORK.etls_Errors force; 
run;
   %rcSet(&syscc); 

/**  Step end Val_prod_hier_cd/prod_lvl **/

/*============================================================================* 
 * Step:            Sort                                    A5W0V4GZ.BH000HDJ * 
 * Transform:       Sort                                                      * 
 * Description:                                                               * 
 *                                                                            * 
 * Source Table:    Data Validation - work.Val_prod_hier_cd A5W0V4GZ.BK000E7M * 
 * Target Table:    Sort - work.STG_PROD_HIER_SORTED        A5W0V4GZ.BK000E7N * 
 *============================================================================*/ 

%let transformID = %quote(A5W0V4GZ.BH000HDJ);
%let trans_rc = 0;
%let etls_stepStartTime = %sysfunc(datetime(), datetime20.); 

/*---- Start of Pre-Process Code  ----*/ 

%di_etl_keep_work_table(Valid_stg_product_hierarchy);
/*---- End of Pre-Process Code  ----*/ 

proc sort data = Valid_stg_product_hierarchy 
   out = work.STG_PROD_HIER_SORTED; 
   by
      PROD_HIER_ASSOC_CD
      PROD_HIER_SK
   ;
run; 

%rcSet(&syserr); 


/**  Step end Sort **/

/*---- Start of User Written Code  ----*/ 

/*============================================================================* 
 * Step:            UW - Remove Duplicate                   A5W0V4GZ.BH000FRP * 
 * Transform:       User Written                                              * 
 * Description:                                                               * 
 *                                                                            * 
 * Source Table:    Sort - work.STG_PROD_HIER_SORTED        A5W0V4GZ.BK000CV9 * 
 * Target Table:    User Written - work.STG_PROD_HIER_NODUP A5W0V4GZ.BK000CVA * 
 *                                                                            * 
 * User Written:    SourceCode                                                * 
 *============================================================================*/ 

%let transformID = %quote(A5W0V4GZ.BH000FRP);
%let trans_rc = 0;
%let etls_stepStartTime = %sysfunc(datetime(), datetime20.); 

/*---- Start of Pre-Process Code  ----*/ 

%di_etl_keep_work_table(STG_PROD_HIER_SORTED);
/*---- End of Pre-Process Code  ----*/ 

data STG_PROD_HIER_NODUP(drop=ETLS_EXCEPTION_COND ETL_ERROR_JOBRUNTIME)
     WORK.STG_PROD_HIER_DUPS(keep=%di_util_column_names(DI_MON.STG_PROD_HIER_X));
set STG_PROD_HIER_SORTED;
attrib ETLS_EXCEPTION_COND length = $250;
attrib ETL_ERROR_JOBRUNTIME length = 8 format=datetime16.; 

by PROD_HIER_ASSOC_CD PROD_HIER_SK;

if not(last.PROD_HIER_SK) then 
   do;
      ETLS_EXCEPTION_COND = put("%etl_msg(mid=5303,args=PROD_ID)",$250.); 
      ETL_ERROR_JOBRUNTIME = "&etls_stepStartTime"dt;
      output WORK.STG_PROD_HIER_DUPS;
   end;
else 
   output STG_PROD_HIER_NODUP;
run;

%rcSet(&syscc); 
proc append base = DI_MON.STG_PROD_HIER_X 
            data=WORK.STG_PROD_HIER_DUPS force; 
run;

%rcSet(&syscc); 
%global etls_recordsBefore1 PROD_ID_1_LVL;
   
proc sort data=di_dm.product_lvl out=prod_lvl(keep=prod_lvl prod_hier_assoc_cd);
   by prod_hier_assoc_cd prod_lvl;
run;

%rcSet(&syscc); 

data _null_;
   set prod_lvl;
   by prod_hier_assoc_cd prod_lvl;
      if last.prod_hier_assoc_cd then
      call symput(cats('g_max_prod_lvl_',prod_hier_assoc_cd),prod_lvl);
run;
%rcSet(&syscc); 

%macro check_existence;
   
%let abort = 0 ;
   
%let etls_recordsBefore1=%di_util_nobs(DI_DM.PRODUCT_HIER_ASSOC_DM);

/* Incremental Load : check if data exist in DI_MON.PARENT_PROD_HIER_SK */
%if &etls_recordsBefore1 > 0 %then %do;
   /* Check for existence of DI_MON.PARENT_PROD_HIER_SK dataset */
   %if NOT %sysfunc(exist(DI_MON.PARENT_PROD_HIER_SK)) %then 
   %do;
      %let etl_msg = %etl_msg(mid=5005,args=DI_MON.PARENT_PROD_HIER_SK);
      %put &etl_msg;
      %let abort = 1 ;
   %end;
   %else %do;
      %let parent_prod_id_obs = %di_util_nobs(DI_MON.PARENT_PROD_HIER_SK);
      %if &parent_prod_id_obs = 0 %then 
      %do;
         %let etl_msg = %etl_msg(mid=5008,args=DI_MON.PARENT_PROD_HIER_SK);
         %put &etl_msg;
         %let abort = 2 ;
      %end;
   %end;


%end;
/* Initial Load : truncate DI_MON.PARENT_PROD_HIER_SK */
%else %if &etls_recordsBefore1 = 0 %then %do;
   %di_util_truncate_table(DI_MON.PARENT_PROD_HIER_SK);
%end;

proc sql noprint;
     select PROD_ID into :PROD_ID_1_LVL from DI_DM.PRODUCT_DM 
     where STD_HIER_PROD_LVL=1;
quit;
%put ______: PROD_ID_1_LVL = &PROD_ID_1_LVL;
   
%if &abort gt 0 %then 
%do;
   %etl_abort;
%end;
%mend check_existence;

%check_existence;
/*---- End of User Written Code  ----*/ 

%macro add_recycled_products(source=);

   /* 
    * Add recycled IDs to STG_PROD_HIER_NODUP if they are not supplied in stg hierarchy 
    * Find recycled IDs which has been supplied in stg_product 
    */

   proc sql;
      create table work.recycled_sk as
      select prod_id, 
             prod_introduction_dt, 
             prod_hier_sk
        from di_dm.product_dm p
       where prod_id in (select prod_id from didm_stg.stg_product)
    group by prod_id
      having count(1) > 1
    order by prod_id, prod_introduction_dt;
   quit;

   %rcSet(&syscc); 
   /*
    * Find out the corresponding recycled SK as (old and new) 
    */

   data work.old_new_sk;
      set work.recycled_sk;
      attrib new_prod_hier_sk old_prod_hier_sk length=6;
      by prod_id prod_introduction_dt;
      last_prod_hier_sk = lag(prod_hier_sk);
      if not first.prod_id and last.prod_id then do;
         new_prod_hier_sk = prod_hier_sk;
         old_prod_hier_sk = last_prod_hier_sk;
         output;
      end;
      keep new_prod_hier_sk old_prod_hier_sk ;
   run;

   %rcSet(&syscc); 

   /* 
    * For a re-cycled prod_hier_sk, get the immediate parent of its previous SK
    * by searching in Parent_prod_hier_sk table.
    * If a new SK is already present in Parent_prod_hier_sk then dont include this
    */

   proc sql;
      create table work.parent_prod_of_recycled_sk as
      Select Old_new_SK.new_prod_hier_sk as prod_hier_sk,
             old_parent.prod_hier_Assoc_cd,
             old_parent.prod_lvl,
             old_parent.parent_prod_hier_sk
        from work.Old_new_SK 
       inner join di_mon.parent_prod_hier_sk old_parent on (old_new_SK.old_prod_hier_sk = old_parent.prod_hier_sk)
       where Old_new_SK.new_prod_hier_sk not in (select prod_hier_sk from di_mon.parent_prod_hier_sk)
    order by 2,1;
   quit;

   %rcSet(&syscc); 

   %if %di_util_nobs(work.parent_prod_of_recycled_sk) gt 0 %then %do;
      data &source;
         merge parent_prod_of_recycled_sk
               &source;
         by prod_hier_assoc_cd prod_hier_sk;
      run;
   %end;
   %rcSet(&syscc); 
%mend;

%add_recycled_products(source=WORK.STG_PROD_HIER_NODUP);

/*---- Start of User Written Code  ----*/ 

/*============================================================================* 
 * Step:            Uw-Lkp_parent_prod_hier_sk              A5W0V4GZ.BH000FRQ * 
 * Transform:       Lookup                                                    * 
 * Description:                                                               * 
 *                                                                            * 
 * Source Tables:   User Written - work.STG_PROD_HIER_NODUP A5W0V4GZ.BK000CVA * 
 *                  PARENT_PROD_HIER_SK -                   A5W0V4GZ.BB0004LG * 
 *                   DI_MON.PARENT_PROD_HIER_SK                               * 
 * Target Tables:   UW - MERGED_PROD_HIERARCHY -            A5W0V4GZ.BK000CVB * 
 *                   work.MERGED_PROD_HIERARCHY                               * 
 *                  STG_PROD_HIERARCHY_6 -                  A5W0V4GZ.BK000CVC * 
 *                   work.STG_PROD_HIERARCHY_6                                * 
 *                                                                            * 
 * User Written:    SourceCode                                                * 
 *============================================================================*/ 

%let transformID = %quote(A5W0V4GZ.BH000FRQ);
%let trans_rc = 0;
%let etls_stepStartTime = %sysfunc(datetime(), datetime20.); 

%let ETLS_SYSLAST = &SYSLAST;

%di_etl_keep_work_table(STG_PROD_HIER_NODUP);

%macro check_input_rec;
%global cnt_rec;
%let cnt_rec =  %di_util_nobs(STG_PROD_HIER_NODUP);

/* Check if stage table is not empty then only proceed */
%if &cnt_rec gt 0 %then %do;
data WORK.MERGED_PROD_HIERARCHY(keep=PROD_HIER_ASSOC_CD PROD_HIER_SK PARENT_PROD_HIER_SK PROD_ID PROD_LVL PARENT_PROD_ID)
     WORK.STG_PROD_LVL_CHG(keep=PROD_HIER_ASSOC_CD PROD_ID PROD_LVL PARENT_PROD_ID)
     WORK.STG_PROD_HIERARCHY_6;
merge DI_MON.PARENT_PROD_HIER_SK(rename=(PROD_LVL=OLD_PROD_LVL) in=indm)
      WORK.STG_PROD_HIER_NODUP(in=instg);
by PROD_HIER_ASSOC_CD PROD_HIER_SK;
if instg and indm and PROD_LVL ne OLD_PROD_LVL then output WORK.STG_PROD_LVL_CHG;
else do;
   if indm then PROD_LVL=OLD_PROD_LVL;
   output WORK.MERGED_PROD_HIERARCHY;
   if instg then output WORK.STG_PROD_HIERARCHY_6;
end;
run;

%rcSet(&syscc); 
data WORK.STG_PROD_LVL_CHG_X(keep=%di_util_column_names(DI_MON.STG_PROD_HIER_X))/VIEW=WORK.STG_PROD_LVL_CHG_X;
   set WORK.STG_PROD_LVL_CHG;
   attrib ETLS_EXCEPTION_COND length = $250;
   attrib ETL_ERROR_JOBRUNTIME length = 8 format=datetime16.;
   ETLS_EXCEPTION_COND = Put(cats(ETLS_EXCEPTION_COND,'0a'x,"%etl_msg(mid=5309, args=PROD_LVL)"),$250.);
   ETL_ERROR_JOBRUNTIME = "&etls_stepStartTime"dt;
run;
%rcSet(&syscc); 

proc append base = DI_MON.STG_PROD_HIER_X 
            data=WORK.STG_PROD_LVL_CHG_X force; 
run;

%end; /* End: Check for an empty stage table */
%else %do; /* If input table is empty */

   data MERGED_PROD_HIERARCHY(keep=PROD_HIER_ASSOC_CD PROD_HIER_SK PARENT_PROD_HIER_SK PROD_ID PROD_LVL PARENT_PROD_ID)
      STG_PROD_HIERARCHY_6(keep= PROD_HIER_ASSOC_CD PROD_HIER_SK PARENT_PROD_HIER_SK PROD_ID 
                                 PROD_LVL PARENT_PROD_ID );
      set STG_PROD_HIER_NODUP;
      stop;
   run;
   %rcSet(&syscc); 
   
%end;

%mend check_input_rec;
%check_input_rec;

/*---- End of User Written Code  ----*/ 

/*============================================================================* 
 * Step:            Lkp_merged_prod_hierarchy               A5W0V4GZ.BH000HDM * 
 * Transform:       Lookup                                                    * 
 * Description:                                                               * 
 *                                                                            * 
 * Source Tables:   STG_PROD_HIERARCHY_6 -                  A5W0V4GZ.BK000E7Q * 
 *                   work.STG_PROD_HIERARCHY_6                                * 
 *                  UW - MERGED_PROD_HIERARCHY -            A5W0V4GZ.BK000E7P * 
 *                   work.MERGED_PROD_HIERARCHY                               * 
 * Target Table:    Lookup - work.STG_PROD_HIER_DETAILS     A5W0V4GZ.BK000E7R * 
 *============================================================================*/ 

%let transformID = %quote(A5W0V4GZ.BH000HDM);
%let trans_rc = 0;
%let etls_stepStartTime = %sysfunc(datetime(), datetime20.); 

/*---- Start of Pre-Process Code  ----*/ 

%di_etl_keep_work_table(STG_PROD_HIERARCHY_6 MERGED_PROD_HIERARCHY);

/*---- End of Pre-Process Code  ----*/ 

%rcSet(&syserr); 
%rcSet(&sqlrc); 


%let runTime = %sysfunc(datetime()); 

/* Creating view to eliminate column name collisions for lookup table  */ 
/*  work.MERGED_PROD_HIERARCHY                                         */ 
proc datasets lib = work nolist nowarn memtype = (data view);
   delete etls_temp_lookupview0;
quit;

proc sql; create view etls_temp_lookupview0 as 
   select 
      PROD_LVL as ETLS_W5RWSDL7,
      PROD_HIER_SK as ETLS_W5RWSDLH,
      PROD_HIER_ASSOC_CD
   from work.MERGED_PROD_HIERARCHY
   ;
quit;
proc datasets lib = work nolist nowarn memtype = (data view);
   delete STG_PROD_HIER_DETAILS;
quit;

/*---- Begin DATA step to perform lookups  ----*/ 
DATA  work.STG_PROD_HIER_DETAILS
         ( keep = PROD_HIER_ASSOC_CD PROD_ID PROD_LVL PARENT_PROD_ID PROD_HIER_SK 
                 PARENT_PROD_HIER_SK PARENT_PROD_LVL )
      ; 
   
   attrib PROD_HIER_ASSOC_CD length=4
          PROD_ID length=$32
          PROD_LVL length=4
          PARENT_PROD_ID length=$32
          PROD_HIER_SK length=6
          PARENT_PROD_HIER_SK length=6
          PARENT_PROD_LVL length=4
          ETLS_W5RWSDL7 length= 4
          ETLS_W5RWSDLH length= 6
          ; 
   
   retain missing0-missing0 0; 
   
   etls_assign_target_value = 0; 
   /* Build hash objects from lookup tables before reading first source row  */ 
   if (_n_ = 1) then 
   do; 
      /* Build hash h0 from lookup table etls_temp_lookupview0 */ 
      nlobs = .; 
      dsid = open("etls_temp_lookupview0"); 
      if (dsid > 0) then 
      do; 
         if ( attrc(dsid, 'MTYPE') = 'DATA' ) then 
            nlobs = attrn(dsid, 'NLOBS'); 
         else 
            nlobs = -1; 
            
         dsid = close(dsid); 
         if (nlobs ^= 0) then 
         do; 
            if (nlobs > 0) then 
               exponent = ceil(log2(nlobs)); 
            else 
               exponent = 8; 
            declare hash h0(dataset: "etls_temp_lookupview0", hashexp: exponent);
            h0.defineKey( "ETLS_W5RWSDLH",
                           "PROD_HIER_ASSOC_CD");
            h0.defineData( "ETLS_W5RWSDL7");
            h0.defineDone();
            if (nlobs = -1) then 
            do; 
               if (h0.Num_Items < 1) then
               do; 
                  put "NOTE: Lookup table is empty: etls_temp_lookupview0";
                  missing0 = 98; 
               end; 
            end; 
         end; 
         else 
         do; 
            put "NOTE: Lookup table is empty: etls_temp_lookupview0";
            missing0 = 98; 
         end; 
      end; 
      else 
      do; 
         put "NOTE: Lookup table does not exist or cannot be opened:"
              " etls_temp_lookupview0";
         
         put "NOTE: Abort action indicated, condition= Lookup table missing:"
              " etls_temp_lookupview0";
         
         abort 3; 
      end; 
      
      call missing (ETLS_W5RWSDLH, PROD_HIER_ASSOC_CD, ETLS_W5RWSDL7); 
   
   end; /* All hash objects have been defined */
   
   /* Read a row from the source table  */ 
   set work.STG_PROD_HIERARCHY_6 end = eof;
   
   /* Is the current key value stored in hash h0?  */ 
   if (missing0 < 1) then 
   do; 
      ETLS_W5RWSDLH = PARENT_PROD_HIER_SK;
      rc0 = h0.find();
      PARENT_PROD_LVL = ETLS_W5RWSDL7;
   end; 
   else 
      rc0 = missing0; 
      
   /* Examine success of lookups  */ 
   if ( rc0=0 ) then 
   do; 
      /* Write row to target  */ 
      output work.STG_PROD_HIER_DETAILS; 
      return; 
   end; 
   else 
   do; 
      error_total + 1; 
      
      if (rc0 ^= 0) then 
      do; 
         exception_total + 1; 
         if (rc0 = 98) then 
         do; 
            /* Check: Lookup table has no rows-Write exception row  */ 
            /* Check: Lookup table has no rows-Set target columns to value  */ 
            /* Check: Lookup table has no rows-Set target columns to missing  */ 
            call missing (PARENT_PROD_LVL); 
            etls_assign_target_value = 1; 
         end; 
         
         else 
         do; 
            /* Check: Lookup value not found-Set target columns to missing  */ 
            call missing (PARENT_PROD_LVL); 
            etls_assign_target_value = 1; 
         end; 
      end; 
      
      /* Set target columns to value/missing requested?  */ 
      if (etls_assign_target_value eq 1) then 
         /* Write row to target  */ 
         output work.STG_PROD_HIER_DETAILS; 
   
   end; /* One or more lookups failed */
   
   if (eof = 1) then 
   do; 
      put "Source records with errors: " error_total ; 
      put "Total lookup exceptions: " exception_total ; 
   end; 

run; 

%rcSet(&syscc); 



/**  Step end Lkp_merged_prod_hierarchy **/

/*============================================================================* 
 * Step:            Data Validation                         A5W0V4GZ.BH000HDN * 
 * Transform:       Data Validation                                           * 
 * Description:                                                               * 
 *                                                                            * 
 * Source Table:    Lookup - work.STG_PROD_HIER_DETAILS     A5W0V4GZ.BK000E7R * 
 * Target Table:    Data Validation -                       A5W0V4GZ.BK000E7S * 
 *                   work.STG_PROD_HIER_VALID                                 * 
 *============================================================================*/ 

%let transformID = %quote(A5W0V4GZ.BH000HDN);
%let trans_rc = 0;
%let etls_stepStartTime = %sysfunc(datetime(), datetime20.); 

/*---- Start of Pre-Process Code  ----*/ 

%di_etl_keep_work_table(STG_PROD_HIER_DETAILS);
/*---- End of Pre-Process Code  ----*/ 

%rcSet(&syserr); 
%rcSet(&sqlrc); 

%macro etls_Validate; 


   proc datasets lib = work nolist nowarn memtype = (data view);
      delete STG_PROD_HIER_VALID;
   quit;
   
   /*---- Begin checks for Custom, Missing Values, and Invalid Values  ----*/ 
   data work.STG_PROD_HIER_VALID
         (keep = PROD_HIER_ASSOC_CD PROD_ID PROD_LVL PARENT_PROD_ID PROD_HIER_SK 
                         PARENT_PROD_HIER_SK PARENT_PROD_LVL)
        work.etls_Errors (keep=%di_util_column_names(DI_MON.STG_PROD_HIER_X));
   
      /* Define lengths for columns with longer lengths in target  */ 
      attrib ETLS_EXCEPTION_COND length = $250; 
	  attrib ETL_ERROR_JOBRUNTIME length = 8 format =datetime16. ;
      
      set STG_PROD_HIER_DETAILS end=eof;
      
      i_move = 0;
      
      /*---- Custom Validation: Parent_prod_id should be at imm higher lvl of  ----*/ 
      /*----  product                                                          ----*/ 
      if (PROD_LVL ne 1 and PARENT_PROD_LVL ne (PROD_LVL-1) and not missing(PARENT_PROD_LVL)) then 
      do; 
         ETLS_EXCEPTION_COND = Put(cats(ETLS_EXCEPTION_COND,'0a'x,"%etl_msg(mid=5318,args=PARENT_PROD_ID)"),$250.); 
         i_move = 1; 
      end;  /* if (PROD_LVL ne 1 and PARENT_PROD_LVL ne (PROD_LVL-1)) */
      else 
      do; 
      end;  /* else */

      if missing(PARENT_PROD_LVL) then 
      do; 
         ETLS_EXCEPTION_COND = Put(cats(ETLS_EXCEPTION_COND,'0a'x,"%etl_msg(mid=5355,args=PARENT_PROD_ID)"),$250.); 
         i_move = 2; 
      end;  /* if (GEO_LVL ne 1 and PARENT_GEO_LVL ne (GEO_LVL-1)) */
      else 
      do; 
      end;  /* else */
      
      /*---- Custom Validation: Parent_prod_sk should be prod_hier_sk for  ----*/ 
      /*----  prod_lvl=1                                                   ----*/ 
      if (PROD_LVL =1 and PROD_HIER_SK ne PARENT_PROD_HIER_SK) then 
      do; 
         PARENT_PROD_HIER_SK = PROD_HIER_SK; 
         PARENT_PROD_ID = PROD_ID; 
      end;  /* if (PROD_LVL =1 and PROD_HIER_SK ne PARENT_PROD_HIER_SK) */
      else 
      do; 
      end;  /* else */
      
      /*---- Custom Validation: PROD_ID change at LVL 1 NOT ALLOWED  ----*/ 
      if (PROD_LVL = 1 & PROD_ID ne "&PROD_ID_1_LVL") then 
      do; 
         PROD_ID = "&PROD_ID_1_LVL"; 
      end;  /* if (PROD_LVL = 1 & PROD_ID ne "&PROD_ID_1_LVL") */
      else 
      do; 
      end;  /* else */
      
      /* move record to error file  */ 
      if (i_move=1) then do;
         ETL_Error_JobRunTime = "&etls_stepStartTime"dt; 
         output work.etls_Errors;
      end;
      else if (i_move=2) then do;
         ETL_Error_JobRunTime = "&etls_stepStartTime"dt; 
         output work.etls_Errors;
         output work.STG_PROD_HIER_VALID;
      end;
	  else
      /* move record to output file  */ 
         output work.STG_PROD_HIER_VALID;      
   run; 
   
   %rcSet(&syscc); 
   
   /* Append the errors table  */ 
   proc append base = DI_MON.STG_PROD_HIER_X 
      data=WORK.etls_Errors force; 
   run;   
   
%mend etls_Validate;
%etls_Validate;

/*---- Start of Post-Process Code  ----*/ 



/**  Step end Data Validation **/

/*---- Start of User Written Code  ----*/ 

/*============================================================================* 
 * Step:            UW - create parent_prod_hier_sk         A5W0V4GZ.BH000FRT * 
 * Transform:       User Written                                              * 
 * Description:                                                               * 
 *                                                                            * 
 * Source Table:    Data Validation -                       A5W0V4GZ.BK000CVE * 
 *                   work.STG_PROD_HIER_VALID                                 * 
 * Target Table:    PARENT_PROD_HIER_SK -                   A5W0V4GZ.BB0004LG * 
 *                   DI_MON.PARENT_PROD_HIER_SK                               * 
 *                                                                            * 
 * User Written:    SourceCode                                                * 
 *============================================================================*/ 

%di_etl_keep_work_table(STG_PROD_HIER_VALID);

%macro create_parent_PROD_hier_sk;

%let new_records = %di_util_nobs(STG_PROD_HIER_VALID);

/*Check if input table is not empty */
%if &new_records > 0 %then %do;

%if NOT %sysfunc(exist(DI_MON.PARENT_PROD_HIER_SK)) or 
    %di_util_nobs(DI_MON.PARENT_PROD_HIER_SK) eq 0 %then 
%do;
   proc sort 
      data=STG_PROD_HIER_VALID(keep=PROD_HIER_ASSOC_CD PROD_HIER_SK PROD_LVL PARENT_PROD_HIER_SK)
      out=DI_MON.PARENT_PROD_HIER_SK;
      by PROD_HIER_ASSOC_CD PROD_HIER_SK;
   run;
   %rcSet(&syscc);
%end;
%else %do;  
      proc sort 
         data=STG_PROD_HIER_VALID(keep=PROD_HIER_ASSOC_CD PROD_HIER_SK PROD_LVL PARENT_PROD_HIER_SK)
         out=work.sorted_parent_prod;
         by PROD_HIER_ASSOC_CD PROD_HIER_SK;
      run;

      %rcSet(&syscc); 
      data DI_MON.PARENT_PROD_HIER_SK;
         merge DI_MON.PARENT_PROD_HIER_SK 
               work.sorted_parent_prod;
         by PROD_HIER_ASSOC_CD PROD_HIER_SK;
      run;
      %rcSet(&syscc); 
   %end;
%end; /* End: Check for empty input table */

%mend;

%create_parent_PROD_hier_sk;

%rcSet(&syserr); 
%rcSet(&sqlrc);
/*---- End of User Written Code  ----*/ 

/*---- Start of User Written Code  ----*/ 

/*============================================================================* 
 * Step:            Extract                                 A5W0V4GZ.BH000FRU * 
 * Transform:       Extract                                                   * 
 * Description:                                                               * 
 *                                                                            * 
 * Source Table:    PARENT_PROD_HIER_SK -                   A5W0V4GZ.BB0004LG * 
 *                   DI_MON.PARENT_PROD_HIER_SK                               * 
 * Target Table:    Extract - work.temp_prod_imm_parent     A5W0V4GZ.BK000CVF * 
 *                                                                            * 
 * User Written:    SourceCode                                                * 
 *============================================================================*/ 

%macro check_indata;

/* Check if stage table is not empty then only proceed */
%if &cnt_rec gt 0 %then %do;

/*---- Map the columns  ----*/ 
proc datasets lib = work nolist nowarn memtype = (data view);
   delete temp_prod_imm_parent;
quit;

%put ______: %str(NOTE: Mapping columns ...);
proc sql;
   create table work.temp_prod_imm_parent as
      select
         PROD_HIER_SK,
         PROD_HIER_ASSOC_CD,
         PROD_LVL,
         PARENT_PROD_HIER_SK,
         (MAX(PROD_LVL - 1, 1)) as PARENT_PROD_LVL length = 4
   from DI_MON.PARENT_PROD_HIER_SK
      where PROD_HIER_ASSOC_CD in (select distinct prod_hier_assoc_cd  
                     from di_dm.product_lvl 
                     where prod_hier_assoc_cd not in (select prod_hier_assoc_cd 
                              from di_dm.product_lvl 
                              where not missing(attr_sk)))
       order by prod_hier_assoc_cd, prod_hier_sk;
quit;
%rcSet(&syscc); 

%end; /* End: Check for an empty stage table */
%else %do; /* If input table is empty */
  data work.temp_prod_imm_parent;
    set DI_MON.PARENT_PROD_HIER_SK;
    attrib PARENT_PROD_LVL length = 4;
    stop;
  run;
%end;

%mend;
%check_indata;

%rcSet(&sqlrc); 


/*---- End of User Written Code  ----*/ 

/*---- Start of User Written Code  ----*/ 

/*============================================================================* 
 * Step:            UW-delete_dangling_nodes                A5W0V4GZ.BH000FRV * 
 * Transform:       User Written                                              * 
 * Description:                                                               * 
 *                                                                            * 
 * Source Table:    Extract - work.temp_prod_imm_parent     A5W0V4GZ.BK000CVF * 
 * Target Table:    User Written -                          A5W0V4GZ.BK000CVG * 
 *                   work.temp_prod_imm_parent                                * 
 *                                                                            * 
 * User Written:    SourceCode                                                * 
 *============================================================================*/ 

%di_etl_keep_work_table(temp_prod_imm_parent STG_PROD_HIER_VALID);

%macro di_etl_delete_dangling_nodes;

   %local lvl max_prod_lvl etl_msg;

   proc sql noprint;
      select distinct prod_hier_assoc_cd into 
         :hier_assoc_cd1-:hier_assoc_cd20
      from di_dm.product_lvl
      where prod_hier_assoc_cd not in (select prod_hier_assoc_cd
               from di_dm.product_lvl
               where not missing(attr_sk));
   quit;

   %let no_of_prod_assoc_cd = &sqlobs;

   %di_util_truncate_table(di_mon.unbalanced_product_hier);


   %do k=1 %to &no_of_prod_assoc_cd;

      %put ______: Delete Dangling nodes for prod_hier_assoc_cd = &&&hier_assoc_cd&k;
      
      %let max_prod_lvl = &&&&g_max_prod_lvl_&&hier_assoc_cd&k ;

/*   Deleting nodes which are not at lowest level & do not have child/children*/
/*   till lowest level*/

      %do lvl=%eval(&max_prod_lvl) %to 2 %by -1;

         proc datasets nodetails nolist nowarn lib=work;
            delete _dangling_nodes unbalanced_nodes;
         quit;

         proc sql;
            create table _dangling_nodes as 
            select prod_hier_assoc_cd length=4, prod_hier_sk length=6
            from (
            select distinct prod_hier_assoc_cd, prod_hier_sk
            from temp_prod_imm_parent
            where prod_lvl eq %eval(&lvl-1)
            and   prod_hier_assoc_cd = &&hier_assoc_cd&k
            except 
            select distinct prod_hier_assoc_cd, parent_prod_hier_sk 
            from temp_prod_imm_parent
            where prod_hier_sk ne parent_prod_hier_sk
            and   prod_lvl eq &lvl 
            and   prod_hier_assoc_cd = &&hier_assoc_cd&k);
         quit;

         %rcSet(&syscc); 
         proc sort data=_dangling_nodes;
            by prod_hier_assoc_cd prod_hier_sk;
         run;

         %if &sqlobs gt 0 %then %do;
         
            %let etl_msg = %etl_msg(mid=5201,args=&sqlobs %eval(&lvl-1));
            %put ______: &etl_msg;
            
            data temp_prod_imm_parent unbalanced_nodes;
               merge temp_prod_imm_parent _dangling_nodes(in=del);
               by prod_hier_assoc_cd prod_hier_sk;
               if del then output unbalanced_nodes;
               else output temp_prod_imm_parent;
            run;
            
            proc append base=di_mon.unbalanced_product_hier data=unbalanced_nodes force;
            run;
            
            %rcSet(&syscc); 
            
         %end;
      %end;

/*  Deleting nodes which do not have parent present in the hierarchy*/

      %do lvl=2 %to %eval(&max_prod_lvl) %by 1;

         proc datasets nodetails nolist nowarn lib=work;
            delete _nodes_with_no_parents unbalanced_nodes;
         quit;

         proc sql;
            create table _nodes_with_no_parents as
            select A.prod_hier_assoc_cd, A.prod_hier_sk, A.prod_lvl
             from temp_prod_imm_parent a inner join
            (
            select prod_hier_assoc_cd,  parent_prod_hier_sk as prod_hier_sk
              from temp_prod_imm_parent c
             where prod_hier_sk ne parent_prod_hier_sk
               and prod_lvl eq &lvl
               and prod_hier_assoc_cd = &&hier_assoc_cd&k
            except
            select prod_hier_assoc_cd,  prod_hier_sk
              from temp_prod_imm_parent d
             where d.prod_lvl eq %eval(&lvl-1)
               and prod_hier_assoc_cd = &&hier_assoc_cd&k
            ) b
            on (a.parent_prod_hier_sk = b.prod_hier_sk)  
            where
                a.prod_hier_assoc_cd = &&hier_assoc_cd&k
            and a.prod_lvl =  &lvl 
            order by prod_hier_assoc_cd, prod_hier_sk;
         quit;

         %rcSet(&syscc); 

         %if &sqlobs gt 0 %then %do;
         
            %let etl_msg = %etl_msg(mid=5201,args=&sqlobs %eval(&lvl-1));
            %put ______: &etl_msg;
           
            data temp_prod_imm_parent unbalanced_nodes;
               merge temp_prod_imm_parent _nodes_with_no_parents(in=del);
               by prod_hier_assoc_cd prod_hier_sk;
               if del then output unbalanced_nodes;
               else output temp_prod_imm_parent;
            run;
            
            proc append base=di_mon.unbalanced_product_hier data=unbalanced_nodes force;
            run;
            
            %rcSet(&syscc); 
            
         %end;
      %end;

%end;

%mend di_etl_delete_dangling_nodes;

%di_etl_delete_dangling_nodes;

%rcSet(&syserr); 
%rcSet(&sqlrc);
/*---- End of User Written Code  ----*/ 

/*---- Start of User Written Code  ----*/ 

/*============================================================================* 
 * Step:            UW - Difference                         A5LPXW0M.BJ0000S9 * 
 * Transform:       User Written                                              * 
 * Description:                                                               * 
 *                                                                            * 
 * Source Tables:   User Written -                          A5LPXW0M.BM0000ON * 
 *                   work.temp_prod_imm_parent                                * 
 *                  PRODUCT_HIER_ASSOC_DM -                 A5LPXW0M.BD0000P1 * 
 *                   DI_DM.PRODUCT_HIER_ASSOC_DM                              * 
 * Target Table:    UW - MERGED_HIERARCHY_HISTORY -         A5LPXW0M.BM0000OP * 
 *                   work.MERGED_HIERARCHY_HISTORY                            * 
 *                                                                            * 
 * User Written:    SourceCode                                                * 
 *============================================================================*/ 

/* If initial load in Product_hier_assoc_dm then
   do not load hierarchy history */
%macro get_PROD_hier_diff;

   /* If source table is not empty then proceed*/
   %if &cnt_rec gt 0 %then %do;

   %let PROD_hier_assoc_dm_rec = %di_util_nobs(DI_DM.PRODUCT_HIER_ASSOC_DM);
   
   %if &PROD_hier_assoc_dm_rec gt 0 %then %do;
      data WORK.IMM_PARENT_PROD_HIER_SK;
         set DI_DM.PRODUCT_HIER_ASSOC_DM;
         where PARENT_PROD_LVL = MAX((PROD_LVL-1),1);
      run;

      proc sort data=WORK.IMM_PARENT_PROD_HIER_SK;
         by prod_hier_assoc_cd prod_hier_sk;
      run;

      data WORK.MERGED_HIERARCHY_HISTORY;
          merge  WORK.IMM_PARENT_PROD_HIER_SK (rename=(parent_PROD_hier_sk=old_parent_PROD_hier_sk) in=inDm)
          WORK.temp_prod_imm_parent(keep=PROD_hier_assoc_cd PROD_hier_sk parent_PROD_hier_sk PROD_lvl PARENT_PROD_LVL
                                   rename=(parent_PROD_hier_sk=new_parent_PROD_hier_sk) in=inStg);
          by PROD_HIER_ASSOC_CD PROD_HIER_SK;
          if (inDm and inStg and old_parent_PROD_hier_sk ne new_parent_PROD_hier_sk) 
          then output WORK.MERGED_HIERARCHY_HISTORY;
          if (NOT inDm and inStg) then 
          do;
             old_parent_PROD_hier_sk = 0;
             output WORK.MERGED_HIERARCHY_HISTORY;
          end;
       run;
       %rcSet(&syscc); 
   %end;
   %else %do;
      data WORK.MERGED_HIERARCHY_HISTORY;
         merge  DI_MON.PARENT_PROD_HIER_SK(obs=0 rename=(parent_PROD_hier_sk=old_parent_PROD_hier_sk))
                WORK.STG_PROD_HIER_VALID(obs=0 keep=PROD_hier_assoc_cd PROD_hier_sk parent_PROD_hier_sk PROD_lvl
               rename=(parent_PROD_hier_sk=new_parent_PROD_hier_sk));
      run;
      %rcSet(&syscc); 
   %end;
   %end; /* End: Check for an empty stage table */
   %else %do; /* If input table is empty */
      data MERGED_HIERARCHY_HISTORY;
         set temp_prod_imm_parent;
         attrib OLD_PARENT_PROD_HIER_SK length = 6;
         attrib NEW_PARENT_PROD_HIER_SK length = 4;
         attrib PROD_LVL_FROM_BOTTOM length = 4;
         stop;
      run;
      %rcSet(&syscc); 
   %end;

%mend;

%get_PROD_hier_diff;
/*---- End of User Written Code  ----*/ 

/*============================================================================* 
 * Step:            Table Loader                            A5W0V4GZ.BH000HDS * 
 * Transform:       Table Loader (Version 2.1)                                * 
 * Description:                                                               * 
 *                                                                            * 
 * Source Table:    UW - MERGED_HIERARCHY_HISTORY -         A5W0V4GZ.BK000E7V * 
 *                   work.MERGED_HIERARCHY_HISTORY                            * 
 * Target Table:    HIERARCHY_HISTORY -                     A5W0V4GZ.BB000AHT * 
 *                   DI_DM.HIERARCHY_HISTORY                                  * 
 *============================================================================*/ 

%let etls_stepStartTime = %sysfunc(datetime(), datetime20.); 

%di_etl_keep_work_table(MERGED_HIERARCHY_HISTORY Temp_prod_imm_parent);

%rcSet(&syserr); 
%rcSet(&sqlrc); 

/*---- Define load data macro  ----*/ 
%macro etls_loader;

   /* Get number of records in table  */ 
   %let etls_recordsBefore = %di_util_nobs(di_dm.HIERARCHY_HISTORY);    
   
   %let etls_table = %nrquote(HIERARCHY_HISTORY);
   %let etls_lib   = %nrquote(DI_DM);
   
   /*---- Map the columns  ----*/ 
   proc datasets lib = work nolist nowarn memtype = (data view);
      delete map;
   quit;
   
   %put ______: %str(NOTE: Mapping columns ...);
   proc sql;
      create view work.map as
         select
            PROD_HIER_ASSOC_CD as HIER_ASSOC_CD,
            (input("&sysdate9",date9.)) as HIER_CHANGE_DT length = 8 format = DATE9. informat = DATE9.,
            (1) as HIER_TYPE length = 4,
            PROD_HIER_SK as HIER_SK,
            OLD_PARENT_PROD_HIER_SK as PREV_PARENT_SK,
            NEW_PARENT_PROD_HIER_SK as NEW_PARENT_SK,
            PROD_LVL as LVL_FROM_TOP
      from MERGED_HIERARCHY_HISTORY
      ;
   quit;
   %rcSet(&syscc); 
   
   /* Determine if the target table exists  */ 
   %let etls_tableExist = %eval(%sysfunc(exist(DI_DM.HIERARCHY_HISTORY, DATA)) or 
                                %sysfunc(exist(DI_DM.HIERARCHY_HISTORY, VIEW))); 
   
   /*---- Create a new table  ----*/ 
   %if (&etls_tableExist eq 0) %then 
   %do;  /* if table does not exist  */ 
   
      %put ______: %str(NOTE: Creating table ...);
      
      data DI_DM.HIERARCHY_HISTORY;
         attrib HIER_ASSOC_CD length = 4; 
         attrib HIER_CHANGE_DT length = 8
            format = DATE9.
            informat = DATE9.; 
         attrib HIER_TYPE length = 4; 
         attrib HIER_SK length = 6; 
         attrib PREV_PARENT_SK length = 6; 
         attrib NEW_PARENT_SK length = 6; 
         attrib LVL_FROM_TOP length = 4; 
         call missing(of _all_);
         stop;
      run;
      
      %rcSet(&syserr); 
      
      /*---- Create the integrity constraints for a table  ----*/ 
      %put ______: %str(NOTE: Creating integrity constraints ...);
      proc datasets library=DI_DM nolist;
         modify HIERARCHY_HISTORY;
            ic create not null (HIER_ASSOC_CD);
            ic create not null (HIER_CHANGE_DT);
            ic create not null (HIER_TYPE);
            ic create not null (HIER_SK);
            ic create not null (PREV_PARENT_SK);
            ic create not null (NEW_PARENT_SK);
            ic create PRIM_KEY = primary key (HIER_ASSOC_CD HIER_CHANGE_DT HIER_TYPE HIER_SK PREV_PARENT_SK);
      quit;
      
      %rcSet(&syserr); 
      
   %end;  /* if table does not exist  */ 

   %di_util_lock(di_dm.HIERARCHY_HISTORY,tries=1000,sleep=10);

   data DI_DM.HIERARCHY_HISTORY;    
      set map (rename=(NEW_PARENT_SK = etls_temp0
                       LVL_FROM_TOP = etls_temp1));      
      modify DI_DM.HIERARCHY_HISTORY
            key = PRIM_KEY;
            
      if _iorc_ in( %sysrc(_DSENMR),%sysrc(_DSENOM),%sysrc(_DSEMTR)) or 
         _iorc_ eq %sysrc(_SOK) then  
      do; 
         NEW_PARENT_SK = etls_temp0;
         LVL_FROM_TOP = etls_temp1;
         
         /* if the record exists in the master, then replace it  */ 
         if _iorc_ eq %sysrc(_SOK) then 
            replace; 
         /* if the record does not exist in the master, then add it  */ 
         else 
            output; 
      end; 
      
      _iorc_ = 0; 
      _error_ = 0;       
   run; 

   %rcSet(&syscc); 
   
   %di_util_unlock(di_dm.HIERARCHY_HISTORY);   
   
   proc datasets lib = work nolist nowarn memtype = (data view);
      delete map;
   quit;
   
 %mend etls_loader;
%etls_loader;

%let etls_recordsAfter=%di_util_nobs(di_dm.HIERARCHY_HISTORY);
%rcSet(&syserr); 

%let etls_endTime = %sysfunc(datetime(),datetime.);

%etls_sendjobstatus(source_table = work.merged_hierarchy_history);

%rcSet(&syserr); 
%rcSet(&sqlrc); 



/**  Step end Table Loader **/

/*---- Start of User Written Code  ----*/ 

/*============================================================================* 
 * Step:            UW-Lookup BUILD HIERARCHY               A5W0V4GZ.BH000FRY * 
 * Transform:       User Written                                              * 
 * Description:                                                               * 
 *                                                                            * 
 * Source Table:    User Written -                          A5W0V4GZ.BK000CVG * 
 *                   work.temp_prod_imm_parent                                * 
 * Target Table:    User Written - work.PROD_HIERARCHY      A5W0V4GZ.BK000CVI * 
 *                                                                            * 
 * User Written:    SourceCode                                                * 
 *============================================================================*/ 

%let SYSLAST = %nrquote(work.temp_prod_imm_parent); 
%let ETLS_SYSLAST = &SYSLAST;

%di_etl_keep_work_table(temp_prod_imm_parent);

%rcSet(&syserr); 
%rcSet(&sqlrc); 

%let etls_last_table = &SYSLAST;
%let trans_rc = 0; 

%macro check_empty_tab;   
   /* make the runTime macro variable to store the run time of the job  */ 
   %let runTime = %sysfunc(datetime(), ); 

/* Check if input stage table is not empty then only proceed */
%if &cnt_rec gt 0 %then %do;
   
   proc datasets lib = work nolist nowarn memtype = (data view);
      delete PROD_HIERARCHY PARENT_PROD_REF;
   quit;

   proc sql;
      create view parent_PROD_ref as
      select PROD_HIER_SK,
             PROD_HIER_ASSOC_CD,
             PARENT_PROD_HIER_SK,
             MAX(PROD_LVL-1,1) as PARENT_PROD_LVL  length=4
      from   DI_MON.PARENT_PROD_HIER_SK;
   quit;
   %rcSet(&syscc); 

   /*---- Begin DATA step to perform lookups  ----*/ 
   DATA  WORK.PROD_HIERARCHY
            (keep = PROD_HIER_SK PROD_LVL PARENT_PROD_HIER_SK 
             PARENT_PROD_LVL PROD_LVL_FROM_BOTTOM
             PROD_HIER_ASSOC_CD)
         ; 
      
      attrib PROD_HIER_SK length=6
             PROD_LVL length=4
             PROD_LVL_FROM_BOTTOM length=4
             PROD_HIER_ASSOC_CD length=4
             PARENT_PROD_HIER_SK length=6
             PARENT_PROD_LVL length=4
             CHILD_SK length=6
             IMM_PARENT_SK length=6
             IMM_PARENT_LVL length=4
             ; 
    
      retain missing0 0 ; 
      
      /* Build hash objects from lookup tables before reading first source row  */ 
      if (_n_ = 1) then 
      do; 
         /* Build hash h0 from lookup table DI_MON.PARENT_PROD_HIER_SK */ 
         nlobs = .; 
         dsid = open("DI_MON.PARENT_PROD_HIER_SK"); 
         if (dsid > 0) then 
         do; 
            if ( attrc(dsid, 'MTYPE') = 'DATA' ) then 
               nlobs = attrn(dsid, 'NLOBS'); 
            else 
               nlobs = -1; 

            dsid = close(dsid); 
            if (nlobs ^= 0) then 
            do; 
               if (nlobs > 0) then 
                  exponent = ceil(log2(nlobs)); 
               else 
                  exponent = 8; 
               declare hash h0(dataset: "WORK.parent_PROD_ref", hashexp: exponent);
               h0.defineKey( "PROD_HIER_SK", "PROD_HIER_ASSOC_CD");
               h0.defineData( "PARENT_PROD_HIER_SK", "PARENT_PROD_LVL");
               h0.defineDone();
               if (nlobs = -1) then 
               do; 
                  if (h0.Num_Items < 1) then
                  do; 
                     put "NOTE: Lookup table is empty: DI_MON.PARENT_PROD_HIER_SK";
                     missing0 = 98; 
                  end; 
               end; 
            end; 
            else 
            do; 
               put "NOTE: Lookup table is empty: DI_MON.PARENT_PROD_HIER_SK";
               missing0 = 98; 
            end; 
         end; 
         else 
         do; 
            put "NOTE: Lookup table does not exist or cannot be opened:"
                 " DI_MON.PARENT_PROD_HIER_SK";
       
            abort 9999; 
         end;            
         
      call missing (PARENT_PROD_HIER_SK, PARENT_PROD_LVL); 
  
      end; /* All hash objects have been defined */
   
      /* Read a row from the source table  */ 
      set &etls_last_table end = eof;
       retain max_PROD_lvl 0;
         by PROD_hier_assoc_cd;
         if first.PROD_hier_assoc_cd then 
             max_PROD_lvl=symget(cats('g_max_PROD_lvl_',PROD_hier_assoc_cd));

         PROD_lvl_from_bottom = max_PROD_lvl-PROD_lvl+1;
         /* Add self association if PROD_lvl ^= parent_PROD_lvl */   
         if PROD_lvl = parent_PROD_lvl then output;
         else 
         do;
            output;
            /* preserve parent PROD_lvl & _sk */
            imm_parent_sk = parent_PROD_hier_sk;
            imm_parent_lvl = parent_PROD_lvl;
            /* Write self association record */
            parent_PROD_hier_sk=PROD_hier_sk;
            PROD_lvl_from_bottom=max_PROD_lvl-PROD_lvl+1;
            parent_PROD_lvl=PROD_lvl;
            if NOT missing(PROD_lvl) then output;
         end;

         parent_PROD_hier_sk = imm_parent_sk;
         parent_PROD_lvl = imm_parent_lvl;

         do while(parent_PROD_lvl > 1);
            child_sk = PROD_hier_sk;
            PROD_hier_sk = parent_PROD_hier_sk;
            rc = h0.find();
            if rc = 0 then do;
               PROD_hier_sk = child_sk;
               output;
            end;
            if rc ^= 0 then do;
               /*Check: Lookup value not found-Set target columns to missing*/
               call missing (parent_PROD_hier_sk, parent_PROD_lvl);
               leave;
            end;
         end;
   
      if (eof = 1) then 
      do; 
         put "NOTE: Source records with errors: error_total ; ";
         put "NOTE: Total lookup exceptions: exception_total ; ";
      end; 
   run;

   %rcSet(&syscc); 
%end; /* End: Check for an empty stage table */
%else %do; /* If input table is empty */
  data PROD_HIERARCHY;
   set temp_prod_imm_parent;
   attrib PROD_LVL_FROM_BOTTOM length = 4;
   stop;
  run;
  %rcSet(&syscc); 
%end;
%mend;
%check_empty_tab;
/*---- End of User Written Code  ----*/ 

/*============================================================================* 
 * Step:            Table Loader                            A5W0V4GZ.BH000HDU * 
 * Transform:       Table Loader (Version 2.1)                                * 
 * Description:                                                               * 
 *                                                                            * 
 * Source Table:    User Written - work.PROD_HIERARCHY      A5W0V4GZ.BK000E7W * 
 * Target Table:    PRODUCT_HIER_ASSOC_DM -                 A5W0V4GZ.BB000AJT * 
 *                   DI_DM.PRODUCT_HIER_ASSOC_DM                              * 
 *============================================================================*/ 

%let transformID = %quote(A5W0V4GZ.BH000HDU);
%let trans_rc = 0;
%let etls_stepStartTime = %sysfunc(datetime(), datetime20.); 

%let SYSLAST = %nrquote(work.PROD_HIERARCHY); 

%let ETLS_SYSLAST = &SYSLAST;
/*---- Start of Pre-Process Code  ----*/ 

%di_etl_keep_work_table(PROD_HIERARCHY);

%macro dm_delete_dangling_nodes(hier_assoc_cds=);
   %local no_of_dangling_nodes max_prod_lvl lvl num_del_hier assoc_cd idx;
   
   %let num_del_hier = %sysfunc(countw(&hier_assoc_cds));
   
   %do idx=1 %to &num_del_hier;
   
      %let assoc_cd = %scan(&hier_assoc_cds, &idx);

      %put ______: Delete Dangling nodes for prod_hier_assoc_cd = &assoc_cd ;

      proc sql noprint;
         select max(prod_lvl) into :max_prod_lvl 
         from di_dm.product_lvl 
         where prod_hier_assoc_cd=&assoc_cd;
      quit;

      %do lvl=%eval(&max_prod_lvl) %to 2 %by -1;
         proc sql;
            create table _dangling_nodes as 
            select prod_hier_sk, prod_hier_assoc_cd 
            from   di_dm.product_hier_assoc_dm 
            where  prod_lvl eq %eval(&lvl-1)
            and    prod_hier_assoc_cd=&assoc_cd
            except 
            select distinct parent_prod_hier_sk, prod_hier_assoc_cd  
            from   di_dm.product_hier_assoc_dm
            where  parent_prod_lvl eq %eval(&lvl-1)
            and    prod_lvl eq &lvl 
            and    prod_hier_assoc_cd=&assoc_cd;
         quit;
         %rcSet(&syscc); 
         %let no_of_dangling_nodes = &sqlobs;
         %if &no_of_dangling_nodes gt 0 %then 
         %do;
            %put ______: Number of dangling nodes deleted=&no_of_dangling_nodes at %eval(&lvl-1);

            %local prod_idx;
            %di_util_index_name(lib=di_dm, 
                                table=product_hier_assoc_dm, 
                                columns=%bquote(prod_hier_sk prod_hier_assoc_cd),
                                _idx_name=prod_idx);

            data di_dm.product_hier_assoc_dm;
               set work._dangling_nodes(keep=prod_hier_sk prod_hier_assoc_cd);
               _iorc_=0;
               do while (_iorc_ eq 0);
                  modify di_dm.product_hier_assoc_dm key=&prod_idx;
                  if _iorc_ eq 0 then remove;
                  else _error_=0;  
               end;   
            run;

            %rcSet(&syscc); 
         %end;
      %end;

      proc datasets nodetails nolist nowarn lib=work;
         delete _dangling_nodes;
      quit;
   
   %end;

%mend dm_delete_dangling_nodes;

%macro prod_hier_assoc_dm_loader(source_recs=, source_data=);

   /* Create target table if it does not exist */ 
   %if %eval(%sysfunc(exist(DI_DM.PRODUCT_HIER_ASSOC_DM, DATA))) = 0 %then %do;
   
      %etl_create2(_SASSchemaFile=&etlp_ddl_path, 
                _tableName=PRODUCT_HIER_ASSOC_DM, _dataset=1, _constraints=0, _index=0,
                LIBREF=DI_DM,DTTMFMT=NLDATM21., DTFMT=DATE9.);
      
   %end;

   /* Get number of records in table  */ 
   %let etls_recordsBefore = %di_util_nobs(DI_DM.PRODUCT_HIER_ASSOC_DM);
      
      
   /*  Back-up Attribute Based hierarchy */
   /*  and then append after loading Non-AttrBased Hierarchy */
   %local hier_cd_to_backup; 

   %let hier_cd_to_backup=0;

   /* Check if input stage table is not empty then only proceed */
   %if &source_recs gt 0 %then %do;

      proc sql noprint;
         select distinct prod_hier_assoc_cd 
         into :hier_cd_to_backup
         separated by ","
         from (
         select prod_hier_assoc_cd 
         from di_dm.product_lvl
         except
         select distinct prod_hier_assoc_cd
         from &source_data);
      quit;

      %rcSet(&syscc); 
      %put ______: HIERARCHY ASSOC to Backup = &hier_cd_to_backup;

      data _PRODUCT_HIER_ASSOC_DM;
         set DI_DM.PRODUCT_HIER_ASSOC_DM;
         where PROD_HIER_ASSOC_CD IN (&hier_cd_to_backup);
      run;

      %rcSet(&syscc); 
      %rcSet(&sqlrc); 

      /* Delete from di_dm.PRODUCT_HIER_ASSOC_DM */
      
      data DI_DM.PRODUCT_HIER_ASSOC_DM;
         set DI_DM.PRODUCT_HIER_ASSOC_DM;
         stop;
      run;
      
      proc append base = DI_DM.PRODUCT_HIER_ASSOC_DM 
                  data = &source_data force; 
      run; 

      %rcSet(&syscc); 

      /*  Append AttrBased Hierarchy back to ASSOC_DM */
      proc append base=DI_DM.PRODUCT_HIER_ASSOC_DM data=work._PRODUCT_HIER_ASSOC_DM force;
      run;

     %rcSet(&syscc); 
      %etl_create2(_SASSchemaFile=&etlp_ddl_path, 
                _tableName=PRODUCT_HIER_ASSOC_DM, _dataset=0, _constraints=1, _index=1,
                LIBREF=DI_DM,DTTMFMT=NLDATM21., DTFMT=DATE9.);
                
      %rcSet(&syscc); 

      /* Delete unbalanced alternate hierarchies (which are explicitly defined in stage) */
      %local non_attr_based_prod_hier;
      proc sql noprint;
         select distinct prod_hier_assoc_cd  
           into :non_attr_based_prod_hier separated by ","           
           from di_dm.product_lvl 
          where prod_hier_assoc_cd not in (select prod_hier_assoc_cd 
                                             from di_dm.product_lvl 
                                            where not missing(attr_sk))
            and prod_hier_assoc_cd gt 1;                                            
      quit;    
      %rcSet(&syscc); 

      %if &non_attr_based_prod_hier ne %str() %then %do;
      
         %local prod_partition_lvl;
         
         %di_util_global_setting_spec(spec_nm=PROD_PARTITION_LVL, 
                                      app=ALL,
                                      _spec_value=prod_partition_lvl);
         
         %rcSet(&sqlrc); 
         
         proc sql;
            create table work._prods_to_del_from_alt_hier as
            select p1.prod_hier_sk,
                   p2.prod_hier_assoc_cd
              from di_dm.product_hier_assoc_dm p1,
                   di_dm.product_hier_assoc_dm p2,
                   di_dm.product_lvl lvl
             where p1.prod_hier_assoc_cd = 1
               and p1.parent_prod_lvl <= &prod_partition_lvl
               and p1.prod_lvl > &prod_partition_lvl

               and p1.prod_hier_sk = p2.prod_hier_sk
			   and p1.parent_prod_lvl = p2.parent_prod_lvl 
               and p2.prod_hier_assoc_cd in (&non_attr_based_prod_hier)
               and p2.parent_prod_hier_sk ne p1.parent_prod_hier_sk 
               
               and lvl.std_hier_prod_lvl <= &prod_partition_lvl
               and lvl.prod_hier_assoc_cd = p2.prod_hier_assoc_cd
               and lvl.prod_lvl = p2.parent_prod_lvl;
         quit;

         %rcSet(&syscc); 
         
         %if %di_util_nobs(work._prods_to_del_from_alt_hier) gt 0 %then %do;

            proc sql;
               create table unbalanced_alt_orphan_prod as 
               select pa.prod_hier_sk, pa.prod_hier_assoc_cd, pa.prod_lvl, pa.parent_prod_hier_sk, pa.parent_prod_lvl
                 from di_dm.product_hier_assoc_dm pa,
                      _prods_to_del_from_alt_hier del
                where pa.parent_prod_hier_sk = del.prod_hier_sk
                  and pa.prod_hier_assoc_cd = del.prod_hier_assoc_cd
                  and pa.prod_lvl = (select max(prod_lvl) from di_dm.product_lvl
                                      where prod_hier_assoc_cd = del.prod_hier_assoc_cd)
                order by pa.prod_hier_assoc_cd, pa.prod_hier_sk;
            quit;      
            %rcSet(&syscc); 
            
            proc append base=di_mon.unbalanced_product_hier 
                        data=work.unbalanced_alt_orphan_prod force;
            quit;
            %rcSet(&syscc); 
            
            data di_mon.parent_prod_hier_sk;
               merge di_mon.parent_prod_hier_sk work.unbalanced_alt_orphan_prod(keep=prod_hier_sk prod_hier_assoc_cd in=del);
               by prod_hier_assoc_cd prod_hier_sk;
               if not del;               
            run;
            %rcSet(&syscc); 
            
            %local prod_idx;
            %di_util_index_name(lib=di_dm, 
                                table=product_hier_assoc_dm, 
                                columns=%bquote(prod_hier_sk prod_hier_assoc_cd),
                                _idx_name=prod_idx);

            data di_dm.product_hier_assoc_dm;
               set work.unbalanced_alt_orphan_prod(keep=prod_hier_sk prod_hier_assoc_cd) ;
               _iorc_=0;
               do while (_iorc_ eq 0);
                  modify di_dm.product_hier_assoc_dm key=&prod_idx;
                  if _iorc_ eq 0 then remove;
                  else _error_=0;  
               end;   
            run;
            %rcSet(&syscc); 
            
            /* After deleting nodes, the hierarchy may become unbalanced */
            /* Remove any dangling nodes if present. */
            %local del_dangling_nodes_from_hier;
            proc sql noprint;
               select distinct prod_hier_assoc_cd
                 into :del_dangling_nodes_from_hier separated by ' '
                 from work._prods_to_del_from_alt_hier;
            quit;
            %rcSet(&syscc); 
            
            %dm_delete_dangling_nodes(hier_assoc_cds=%bquote(&del_dangling_nodes_from_hier));

            data _stg_prod_hier_x;
               attrib PROD_HIER_ASSOC_CD length=4 PROD_ID length=$32 PROD_LVL length=4 PARENT_PROD_ID length=$32 
                      ETLS_EXCEPTION_COND length=$250 ETL_ERROR_JOBRUNTIME length=8; 
               num_hier=countw("&del_dangling_nodes_from_hier");
               PROD_ID = "%etl_msg(mid=5429)";
               ETL_ERROR_JOBRUNTIME = datetime();
               ETLS_EXCEPTION_COND ="%etl_msg(mid=5428)";
               do idx=1 to num_hier;
                  PROD_HIER_ASSOC_CD = input(scan("&del_dangling_nodes_from_hier",idx),best.);
                  output;
               end;
               drop num_hier idx; 
            run;   
            %rcSet(&syscc); 
            
            proc append base=di_mon.stg_prod_hier_x 
                 data=_stg_prod_hier_x force;
            run;
            %rcSet(&syscc); 
            
            proc datasets lib = work nolist nowarn memtype = (data view);
               *delete _prods_to_del_from_alt_hier unbalanced_alt_orphan_prod _stg_prod_hier_x;
            quit;            

         %end;
            
      %end;

   %end;
   
   %let etls_recordsAfter = %di_util_nobs(DI_DM.PRODUCT_HIER_ASSOC_DM);
      
%mend prod_hier_assoc_dm_loader;

%prod_hier_assoc_dm_loader(source_recs=&cnt_rec, source_data=work.PROD_HIERARCHY);

%let etls_table = %nrquote(PRODUCT_HIER_ASSOC_DM);
%let etls_lib   = %nrquote(DI_DM);

/*---- End of Post-Process Code  ----*/ 
%rcSet(&syserr); 
%rcSet(&sqlrc); 

/**  Step end Table Loader **/
%let etls_endTime = %sysfunc(datetime(),datetime.);

/*---- Job status macro  ----*/ 
%etls_sendjobstatus(source_table = didm_stg.stg_product_hierarchy);
